// DLMdisplay.h

/* Beside the standard NSL display we use a special display for the
   trajectory of the blob and the net display of the connectivity. It
   is a C++-class called "XMonoWin" with very simple X11 display
   routines. */

static const int winWidth=220;         // size of the display window ;

class DlmDisplay : public NslModule
{
public:

private:
	XMonoWin winT1; 
	XMonoWin winT2;
	XMonoWin winW;
	XMonoWin winC;

	NslFloat0 netWeightExp; // exponent for the net display computation ;
	NslFloat2 gravI2; // center of gravity for the connections ;
	NslFloat2 gravJ2; // center of gravity for the connections ;

	NslFloat4 correl21LI;  // leaky correlation integrated ;
	NslFloat4 w21;
	NslFloat2 Sh1;
	NslFloat2 Sh2;

	float centerI, centerJ;  // center of gravity ;
	int frame,i1max,j1max,i2max,j2max,i1Rmax,j1Rmax; 

public:
	DlmDisplay(nsl_string,NslModule*);
	~DlmDisplay() {}

	void memAlloc(int,int,int,int,int,int,int);
	void initRun();
	void simRun();

	void centerOfGravity(nsl_num_2&, float, float);
	void showTrajectory(nsl_matrix&, int, XMonoWin&);
	void showNet(nsl_num_4&, int, XMonoWin&,int, int, int, int, int, int,
		NslFloat0&, NslFloat2&, NslFloat2&);

};

